# Class AbstractProjectBasedReportTask<T>

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.api.internal.ConventionTask
org.gradle.api.tasks.diagnostics.ConventionReportTask
org.gradle.api.tasks.diagnostics.AbstractProjectBasedReportTask<T>

Type Parameters:
  `T` - The report model type

All Implemented Interfaces:
  `Comparable<Task>, org.gradle.api.internal.DynamicObjectAware, org.gradle.api.internal.IConventionAware, org.gradle.api.internal.TaskInternal, Named, ExtensionAware, Task, Configurable<Task>`

Direct Known Subclasses:
  `AbstractDependencyReportTask, ProjectReportTask, PropertyReportTask`

@Incubating @DisableCachingByDefault(because="Abstract super-class, not to be instantiated directly") public abstract class AbstractProjectBasedReportTask<T> extends ConventionReportTask
The base class for all Project based project report tasks.

Since:
  7.6

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface Named

  `Named.Namer`

- ## Field Summary

  ### Fields inherited from interface Task

  `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractProjectBasedReportTask()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `(package private) void`
  `action()`
  `protected abstract T`
  `calculateReportModelFor(Project project)`
  `protected void`
  `generateReportFooterFor(Map<org.gradle.api.tasks.diagnostics.internal.ProjectDetails, T> modelsByProjectDetails)`
  Provides a means of printing a customizable footer section below the per-project details body of the report.
  `protected abstract void`
  `generateReportFor(org.gradle.api.tasks.diagnostics.internal.ProjectDetails project, T model)`
  `protected void`
  `generateReportHeaderFor(Map<org.gradle.api.tasks.diagnostics.internal.ProjectDetails, T> modelsByProjectDetails)`
  Provides a means of printing a customizable header section above the per-project details body of the report.

  ### Methods inherited from class ConventionReportTask

  `clickableOutputFileUrl, getClientMetaData, getOutputFile, getProjectReportDirectory, getProjects, getRenderer, getTextOutputFactory, logClickableOutputFileUrl, reportGenerator, setOutputFile, setProjects, shouldCreateReportFile`

  ### Methods inherited from class org.gradle.api.internal.ConventionTask

  `conventionMapping, conventionMapping, getConventionMapping`

  ### Methods inherited from class DefaultTask

  `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

  ### Methods inherited from class org.gradle.api.internal.AbstractTask

  `acceptServiceReferences, appendParallelSafeAction, doNotTrackState, doNotTrackStateIf, getAsDynamicObject, getIdentityPath, getImpliesSubProjects, getLifecycleDependencies, getOnlyIf, getReasonNotToTrackState, getReasonsNotToTrackState, getReasonTaskIsIncompatibleWithConfigurationCache, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isCompatibleWithConfigurationCache, isEnabled, isHasCustomActions, notCompatibleWithConfigurationCache, prependParallelSafeAction, restoreOnlyIf, restoreTaskActions, setImpliesSubProjects`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface Task

  `doNotTrackState, notCompatibleWithConfigurationCache`

- ## Constructor Details

  - ### AbstractProjectBasedReportTask

    public AbstractProjectBasedReportTask()

- ## Method Details

  - ### calculateReportModelFor

    protected abstract T calculateReportModelFor(Project project)

  - ### generateReportHeaderFor

    @Incubating protected void generateReportHeaderFor(Map<org.gradle.api.tasks.diagnostics.internal.ProjectDetails, T> modelsByProjectDetails)
    Provides a means of printing a customizable header section above the per-project details body of the report.

    By default, there is no header information printed.

    Parameters:
      `modelsByProjectDetails` - information about the projects under report
    Since:
      8.9

  - ### generateReportFor

    protected abstract void generateReportFor(org.gradle.api.tasks.diagnostics.internal.ProjectDetails project, T model)

  - ### generateReportFooterFor

    @Incubating protected void generateReportFooterFor(Map<org.gradle.api.tasks.diagnostics.internal.ProjectDetails, T> modelsByProjectDetails)
    Provides a means of printing a customizable footer section below the per-project details body of the report.

    By default, there is no footer information printed.

    Parameters:
      `modelsByProjectDetails` - information about the projects under report
    Since:
      8.9

  - ### action

    void action()